local AddonName, FlightMasterOribos = ...
local FlightMasterOribos = LibStub("AceAddon-3.0"):NewAddon(FlightMasterOribos, AddonName, "AceConsole-3.0", 'AceEvent-3.0')
local uid = nil

function FlightMasterOribos:OnInitialize()
    self.db = self:CreateDb()
    self:RegisterChatCommand('fmo', 'HandleChatCommand')
	self:RegisterChatCommand('flightmasteroribos', 'HandleChatCommand')
	
	self:RegisterEvent("ZONE_CHANGED")
	self:RegisterEvent("ZONE_CHANGED_INDOORS")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
end

function FlightMasterOribos:ZONE_CHANGED_INDOORS()
	if not TomTom then return end

	local mapId = C_Map.GetBestMapForUnit("player")

	if mapId and mapId == 1671 then
		uid = TomTom:AddWaypoint(1671, 60.48/100, 68.00/100, { title = "Oribos Flight Master", persistent = false, minimap = self.db.global.minimapEnabled, world = false, crazy = self.db.global.arrowEnabled or false })
	else
		self:RemoveWaypoints()
	end
end

function FlightMasterOribos:ZONE_CHANGED()
	self:RemoveWaypoints()
end

function FlightMasterOribos:ZONE_CHANGED_NEW_AREA()
	self:RemoveWaypoints()
end

function FlightMasterOribos:RemoveWaypoints()
	if not TomTom then return end
	
	if uid == nil then
		return
	end
	
	TomTom:RemoveWaypoint(uid)
end

local function GetEnabledOrDisabledText(value)
	if value ~= nil and value == true then
		return "|cAA00FF00Enabled|r"
	else
		return "|cAAFF0000Disabled|r"
	end
end

function FlightMasterOribos:HandleChatCommand(input)
    local args = {strsplit(' ', input)}

	if args and args[1] == "arrow" then
		self.db.global.arrowEnabled = not self.db.global.arrowEnabled
		print("Waypoint Arrow: " .. GetEnabledOrDisabledText(self.db.global.arrowEnabled))
	elseif args and args[1] == "minimap" then
		self.db.global.minimapEnabled = not self.db.global.minimapEnabled
		print("Minimap Dot: " .. GetEnabledOrDisabledText(self.db.global.minimapEnabled))
	else
		print("Flight Master Oribos - Available commands:")
		print("/fmo arrow - Toggles waypoint arrow. Current value: " .. GetEnabledOrDisabledText(self.db.global.arrowEnabled))
		print("/fmo minimap - Toggles minimap dot. Current value: " .. GetEnabledOrDisabledText(self.db.global.minimapEnabled))
	end
end

function FlightMasterOribos:CreateDb()
    return LibStub('AceDB-3.0'):New(AddonName, {
        global = {
            arrowEnabled = true,
			minimapEnabled = true
        }
    })
end
